<?php
/**
 * Clase Base DP para BaseCrCierrehipotecaDDP
 *
 * @package    
 * @subpackage BaseCrCierrehipotecaDDP
 * @author     Willy
 * @version    SVN:: BaseCrCierrehipotecaDDP.class.php,v 1.1 2013-02-06 11:51:29 william.taype Exp $
 */
abstract class BaseCrCierrehipotecaDDP extends CrCierrehipotecaDBN
{
  /* N�mero de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrCierrehipotecaDBN )
    {
      $o_CrCierrehipotecaDBN = $bSetDefault;
      if($o_CrCierrehipotecaDBN->getIdcierred()) : $this->setIdcierred($o_CrCierrehipotecaDBN->getIdcierred()); endif;
      if($o_CrCierrehipotecaDBN->getIdcolaborador()) : $this->setIdcolaborador($o_CrCierrehipotecaDBN->getIdcolaborador()); endif;
      if($o_CrCierrehipotecaDBN->getNombrecolaborador()) : $this->setNombrecolaborador($o_CrCierrehipotecaDBN->getNombrecolaborador()); endif;
      if($o_CrCierrehipotecaDBN->getIngresototal()) : $this->setIngresototal($o_CrCierrehipotecaDBN->getIngresototal()); endif;
      if($o_CrCierrehipotecaDBN->getSalidatotal()) : $this->setSalidatotal($o_CrCierrehipotecaDBN->getSalidatotal()); endif;
      if($o_CrCierrehipotecaDBN->getSaldototal()) : $this->setSaldototal($o_CrCierrehipotecaDBN->getSaldototal()); endif;
      if($o_CrCierrehipotecaDBN->getFecharegistro()) : $this->setFecharegistro($o_CrCierrehipotecaDBN->getFecharegistro()); endif;
      if($o_CrCierrehipotecaDBN->getUsaurioregistro()) : $this->setUsaurioregistro($o_CrCierrehipotecaDBN->getUsaurioregistro()); endif;
      if($o_CrCierrehipotecaDBN->getIdsucursal()) : $this->setIdsucursal($o_CrCierrehipotecaDBN->getIdsucursal()); endif;
      if($o_CrCierrehipotecaDBN->getFecha()) : $this->setFecha($o_CrCierrehipotecaDBN->getFecha()); endif;
    }
  }

  /* Obtiene el n�mero de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(idcierred),(MAX(idcierred)+1), 1) AS Maximo FROM cr_cierrehipoteca_d;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdcierred($row[0]);

      if($this->getIdcierred()){
        $a_Fields = array();

        if($this->getIdcierred()) : $a_Fields['idcierred'] = ($this->getIdcierred()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;
        if($this->getMoneda()) : $a_Fields['moneda'] = ($this->getMoneda()); endif;
        if($this->getNombrecolaborador()) : $a_Fields['nombrecolaborador'] = ($this->getNombrecolaborador()); endif;
        if($this->getIngresototal()) : $a_Fields['ingresototal'] = ($this->getIngresototal()); endif;
        if($this->getIngresototalga()) : $a_Fields['ingresototalga'] = ($this->getIngresototalga()); endif;
        if($this->getIngresototalDeposito()) : $a_Fields['ingresototaldeposito'] = ($this->getIngresototalDeposito()); endif;
        if($this->getIngresototalPI()) : $a_Fields['ingresototalpi'] = ($this->getIngresototalPI()); endif;
        if($this->getSalidatotal()) : $a_Fields['salidatotal'] = ($this->getSalidatotal()); endif;
        if($this->getSalidatotalPI()) : $a_Fields['salidatotalpi'] = ($this->getSalidatotalPI()); endif;
        if($this->getSaldototal()) : $a_Fields['saldototal'] = ($this->getSaldototal()); endif;
        if($this->getFecharegistro()) : $a_Fields['fecharegistro'] = ($this->getFecharegistro()); endif;
        if($this->getUsaurioregistro()) : $a_Fields['usaurioregistro'] = ($this->getUsaurioregistro()); endif;
        if($this->getIdsucursal()) : $a_Fields['idsucursal'] = ($this->getIdsucursal()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_cierrehipoteca_d (".$sStringField.") VALUES (".$sStringValue.");";
		//echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdcierred())
      {
        $a_Fields = array();

        if($this->getIdcierred()) : $a_Fields['idcierred'] = ($this->getIdcierred()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;
        if($this->getNombrecolaborador()) : $a_Fields['nombrecolaborador'] = ($this->getNombrecolaborador()); endif;
        if($this->getIngresototal()) : $a_Fields['ingresototal'] = ($this->getIngresototal()); endif;
        if($this->getSalidatotal()) : $a_Fields['salidatotal'] = ($this->getSalidatotal()); endif;
        if($this->getSaldototal()) : $a_Fields['saldototal'] = ($this->getSaldototal()); endif;
        if($this->getFecharegistro()) : $a_Fields['fecharegistro'] = ($this->getFecharegistro()); endif;
        if($this->getUsaurioregistro()) : $a_Fields['usaurioregistro'] = ($this->getUsaurioregistro()); endif;
        if($this->getIdsucursal()) : $a_Fields['idsucursal'] = ($this->getIdsucursal()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_cierrehipoteca_d SET ".$sStringField." WHERE 1 AND idcierred='".$this->getIdcierred()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
     if($this->getIdsucursal() && $this->getFecha())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_cierrehipoteca_d WHERE 1 AND idsucursal='".$this->getIdsucursal()."' AND fecha='".$this->getFecha()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* B�squeda del registro por la llave primaria */
  public static function selectByPK($vIdcierred)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idcierred, idcolaborador, nombrecolaborador, ingresototal, ingresototaldeposito, salidatotal, saldototal, fecharegistro, usaurioregistro, idsucursal, fecha FROM cr_cierrehipoteca_d WHERE 1 AND idcierred='".$vIdcierred."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrCierrehipotecaDDP = new CrCierrehipotecaDDP();
    $o_CrCierrehipotecaDDP->setIdcierred($o_propel->idcierred);
    $o_CrCierrehipotecaDDP->setIdcolaborador($o_propel->idcolaborador);
    $o_CrCierrehipotecaDDP->setNombrecolaborador($o_propel->nombrecolaborador);
    $o_CrCierrehipotecaDDP->setIngresototal($o_propel->ingresototal);
    $o_CrCierrehipotecaDDP->setIngresototalDeposito($o_propel->ingresototaldeposito);
    $o_CrCierrehipotecaDDP->setSalidatotal($o_propel->salidatotal);
    $o_CrCierrehipotecaDDP->setSaldototal($o_propel->saldototal);
    $o_CrCierrehipotecaDDP->setFecharegistro($o_propel->fecharegistro);
    $o_CrCierrehipotecaDDP->setUsaurioregistro($o_propel->usaurioregistro);
    $o_CrCierrehipotecaDDP->setIdsucursal($o_propel->idsucursal);
    $o_CrCierrehipotecaDDP->setFecha($o_propel->fecha);
    return $o_CrCierrehipotecaDDP;
  }
}